import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.sql.*;
import java.io.*;
public class MyGraphicAnalysis implements ActionListener 
{
	Connection conn=null;
	ResultSet rs;
	String user;
		
	JPanel panel1;
	JPanel panel2,panel3;
	JPanel mainPanel;
	JFrame frame;

	JCheckBox[] fieldRadios;
	JRadioButton[] fieldradios;
	JButton barChart,pieChart,scatterDiagram;
        JButton show,logoutButton,analysisButton;
	ButtonGroup group = new ButtonGroup();
	ButtonGroup g1s = new ButtonGroup();
	ButtonGroup g2s = new ButtonGroup();

	JComboBox xAxis,sec;
	JRadioButton[] xs,ys;


	int noOfFields;
	int choice;

public MyGraphicAnalysis(String u,Connection dbconn){user=new String(u);conn=dbconn; SetUp(); choice=0;}

private void SetUp()
{
	panel1=new JPanel(new GridLayout(0,1));
	panel1.setBorder(BorderFactory.createEmptyBorder(30,30,10,30));
	barChart=new JButton("Bar Graph");
	pieChart=new JButton("Pie Chart");
	scatterDiagram=new JButton("Scatter Diagram");
	panel1.add(barChart);
	panel1.add(pieChart);
	panel1.add(scatterDiagram);	
	barChart.addActionListener(this);
	pieChart.addActionListener(this);
	scatterDiagram.addActionListener(this);
        String[] range = { "1", "2","3", "4", "5","6", "7","8","9","10","11" };
        String[] section = { "2","3", "4", "5","6", "7","8","9","10" };
	xAxis=new JComboBox(range);
	sec=new JComboBox(section);

	panel3=new JPanel(new FlowLayout());
        panel3.setBorder(BorderFactory.createEmptyBorder(30,30,10,30));

	analysisButton=new JButton("Query Form");
        analysisButton.setMnemonic(KeyEvent.VK_A);
        panel3.add(analysisButton);
        analysisButton.addActionListener(this);

        logoutButton=new JButton("Logout");
        logoutButton.setMnemonic(KeyEvent.VK_L);
        panel3.add(logoutButton);
        logoutButton.addActionListener(this);
}
	
public void createComponents()
{
SetUp();
System.out.println("Iam creating components for "+choice);
panel2=new JPanel(new GridLayout(0,1));
panel2.setBorder(BorderFactory.createEmptyBorder(30,30,10,30));
switch(choice)
{
case 1:
	{
		System.out.println("constructing Bar graph..");
		String query="select count(*) from G24_T2";
		try{
	        System.out.println("the query executed is :"+query);
                PreparedStatement p=conn.prepareStatement(query);
                rs=null;
                rs=p.executeQuery();
                rs.next();
                noOfFields=Integer.parseInt(rs.getString(1));
                fieldRadios=new JCheckBox[noOfFields];
                query="select * from G24_T2 order by id";
                p=conn.prepareStatement(query);
                rs=null;
                rs=p.executeQuery();
                int counter=0;
                while(rs.next())
                {
                fieldRadios[counter]=new JCheckBox(rs.getString(2));
                panel2.add(fieldRadios[counter]);
                counter++;
                }
		System.out.println("Iam creating components on panle 2 for bar graph");
		panel2.add(new JLabel(""));
		panel2.add(new JLabel("Select range for X Axis"));
		panel2.add(xAxis);
		panel2.add(new JLabel(""));
		show=new JButton("Show Graph");
	        show.setMnemonic(KeyEvent.VK_S);
        	panel2.add(show);
        	show.addActionListener(this);
		break;
		
	}catch(Exception e){ System.out.println("Exception is :"+e); }
	}// end of case bar graph

case 2:
	{	
	try{
                System.out.println("creating components for pie chart");
                String query="select count(*) from G24_T2";
                System.out.println("the query executed is :"+query);
                PreparedStatement p=conn.prepareStatement(query);
                rs=null;
                rs=p.executeQuery();
                rs.next();
                noOfFields=Integer.parseInt(rs.getString(1));
                fieldradios=new JRadioButton[noOfFields];
                query="select * from G24_T2 order by id";
                p=conn.prepareStatement(query);
                rs=null;
                rs=p.executeQuery();
                int counter=0;
                while(rs.next())
                {
                fieldradios[counter]=new JRadioButton(rs.getString(2));
                panel2.add(fieldradios[counter]);
		group.add(fieldradios[counter]);
                counter++;
                }
		fieldradios[0].setSelected(true);
                System.out.println("Iam creating components on panel 2 for pie chart");
                panel2.add(new JLabel(""));
                panel2.add(new JLabel("Select No:of sections for pie chart"));
                panel2.add(sec);
                panel2.add(new JLabel(""));
                show=new JButton("Show Graph");
                show.setMnemonic(KeyEvent.VK_S);
                panel2.add(show);
                show.addActionListener(this);
		System.out.println("Creating Pie chart");
		break;
        }catch(Exception e){ System.out.println("Exception is :"+e); }
        }// end of pie chart
case 3:
  {
                System.out.println("constructing scatter graph..");
                String query="select count(*) from G24_T2";
                try{
                System.out.println("the query executed is :"+query);
                PreparedStatement p=conn.prepareStatement(query);
                rs=null;
                rs=p.executeQuery();
                rs.next();
                noOfFields=Integer.parseInt(rs.getString(1));
                xs=new JRadioButton[noOfFields];
                ys=new JRadioButton[noOfFields];
                query="select * from G24_T2 order by id";
                p=conn.prepareStatement(query);
                rs=null;
                rs=p.executeQuery();
                int counter=0;
		JPanel pan=new JPanel(new GridLayout(0,2));
                while(rs.next())
                {
                xs[counter]=new JRadioButton(rs.getString(2));
                panel2.add(xs[counter]);
		xs[counter].addActionListener(this);
                ys[counter]=new JRadioButton(rs.getString(2));
                panel2.add(ys[counter]);
		ys[counter].addActionListener(this);
		g1s.add(xs[counter]);
		g2s.add(ys[counter]);
		pan.add(xs[counter]);
		pan.add(ys[counter]);
                counter++;
		}
                System.out.println("Iam creating components on panle 2 for scatter graph");
                panel2.add(new JLabel(""));
                panel2.add(pan);
                panel2.add(new JLabel(""));
                show=new JButton("Show Graph");
                show.setMnemonic(KeyEvent.VK_S);
                panel2.add(show);
                show.addActionListener(this);
		break; 
}catch(Exception exp){ System.out.println("exception "+exp); }
}
}
}
public void actionPerformed(ActionEvent e) 
{   
if("Show Graph".equals(e.getActionCommand()))
{
if(choice==1)
{
System.out.println("u have pressed to show bar graph");
int[] id=new int[noOfFields];
int count=0;
int i=0;
while(count<noOfFields)
{
	if(fieldRadios[count].isSelected())
	{
	 System.out.println("combo  "+count+" is selected");
	 id[i]=count+1;	
	 i++;
	}
count++;
}
int sections=xAxis.getSelectedIndex();
    sections++;
System.out.println("and the no of sections are"+sections);
JFrame barFrame=new JFrame("Bar Graph");
JFrame.setDefaultLookAndFeelDecorated(true);
barFrame.setSize(1000, 700);
prac bars=new prac(id,i,sections,conn);
//bars.setSize(1000,700);
barFrame.getContentPane().add(bars);
//barFrame.pack();
barFrame.setVisible(true);
barFrame.setLocation(10,10);
}
else if(choice==2)	/// pie
{
System.out.println("u have pressed to show pie graph");

int slices=sec.getSelectedIndex();  // increment id
slices++;
int c=0;
while(c<noOfFields)
{
 if(fieldradios[c].isSelected()){ break; }
 c++;
}
System.out.println("so u selected "+c+" as id and slices as "+slices);
JFrame picframe = new JFrame("Pie Chart for "+fieldradios[c].getText());
System.out.println("created a new frame for pie chart");
/*----------------- creating data for pie chart------------------------------*/
c++; slices++;
int[] grade=new int[11];
int index=0;
while(index<11)
{
 try{
	String q=new String("select count(*) from G24_T3 where id="+c+" and marks="+index);
	System.out.println("The query is "+q);
	
        PreparedStatement p=conn.prepareStatement(q);
        rs=null;
        rs=p.executeQuery();
        rs.next();
	grade[index]=Integer.parseInt(rs.getString(1));
	System.out.println("the value is:"+grade[index]);
    }catch(Exception e2){ System.out.println("Exception"+e2); }
index++;
}
/*picframe.getContentPane().add(new MyComponent(c+1,slices+1,conn));
System.out.println("painted pie chart");
picframe.setSize(300, 200);
picframe.setVisible(true);*/
              JFrame.setDefaultLookAndFeelDecorated(true);
              picframe.setSize(1000, 700);
	      pie piePanel=new pie(slices,grade);
           //   JPanel pane=new JPanel(new FlowLayout()); r
	   //   pane.setBorder(BorderFactory.createEmptyBorder(130,130,110,130)); r
	   //   pane.add(piePanel); r
	   //   pane.setVisible(true); r
	  //    piePanel.setSize(100,100);  r
              picframe.getContentPane().add(piePanel);  
            //  picframe.pack();  
// 	      picframe.add(piePanel);
              picframe.setVisible(true);
              picframe.setLocation(10,10);
System.out.println("pie chart is now displayed");
}
else if(choice==3)	//scatter diagram
{
drawScatteredGraph();
}// end of scatter diagram
}
else if("Bar Graph".equals(e.getActionCommand()))  
{
choice=1;
frame.dispose();
this.createAndShowGUI();
}
else if("Pie Chart".equals(e.getActionCommand()))
{
choice=2;
frame.dispose();
this.createAndShowGUI();
}
else if("Scatter Diagram".equals(e.getActionCommand()))
{
choice=3;
frame.dispose();
this.createAndShowGUI();
}
else if("Query Form".equals(e.getActionCommand()))
{
System.out.println("\nSo u want to submit query again");
AnalysisForm analysis=new AnalysisForm(user,conn);
frame.dispose();
analysis.createAndShowGUI();
}
else if("Logout".equals(e.getActionCommand()))
//log out
{
frame.dispose();
SwingApplication loginForm;
loginForm=new SwingApplication();
loginForm.createAndShowGUI();
}
else{ 
int c=0;
while(c<noOfFields)
{
ys[c].setVisible(true);
c++;
}c=0;
while(c<noOfFields)
{
 	if(xs[c].isSelected()){ ys[c].setVisible(false); break; }
//        if(ys[c].isSelected()){ xs[s].setVisible(false); }
c++;
}
}
}

public void createAndShowGUI()
{
JFrame.setDefaultLookAndFeelDecorated(true);
frame = new JFrame("Graphical Analysis");
frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
frame.setSize(new Dimension(200, 220));
this.createComponents();
System.out.println("attaching panel1");
frame.getContentPane().add(panel1, BorderLayout.NORTH);
System.out.println("attaching panel2");
frame.getContentPane().add(panel2, BorderLayout.CENTER);
System.out.println("attaching panel3");
frame.getContentPane().add(panel3, BorderLayout.SOUTH);
frame.pack();
frame.setVisible(true);
}


public void drawScatteredGraph()
{
int n=0;
                System.out.println("constructing scatter graph parameters ..");
                String query="select distinct user from G24_T3";
                try{
                System.out.println("the query executed is :"+query);
                PreparedStatement p=conn.prepareStatement(query);
                rs=null;
                rs=p.executeQuery();
		while(rs.next()){ n++; }
                System.out.println("no of logins are "+n);
int c=0;
int x=0;
while(c<noOfFields)
{
	if(xs[c].isSelected())
	{
	x=c+1;
	break;
	}
c++;
}
c=0;
int y=0;
while(c<noOfFields)
{
        if(ys[c].isSelected())
        {
        y=c+1;
        break;
        }
c++;
}
System.out.println("the selected values are "+x+" and "+y);
query=new String("select marks from G24_T3 where id="+x);
p=conn.prepareStatement(query);
rs=null;
rs=p.executeQuery();
int[] xval=new int[n];
c=0;
while(rs.next())
{
 xval[c]=Integer.parseInt(rs.getString(1));
 c++;
}
query=new String("select marks from G24_T3 where id="+y);
p=conn.prepareStatement(query);
rs=p.executeQuery();
int[] yval=new int[n];
c=0;
while(rs.next())
{
 yval[c]=Integer.parseInt(rs.getString(1));
 c++;
}
JFrame.setDefaultLookAndFeelDecorated(true);
JFrame sFrame;
sFrame = new JFrame("Scatter Diagram");
//sFrame.setSize(new Dimension(800,400));  r
sFrame.setSize(1000,700);  // r
scatter s= new scatter();
s.getX(xval);
s.getY(yval);
s.getN(n);
sFrame.getContentPane().add(s);
//sFrame.pack();
//frame.setVisible(false);
sFrame.setVisible(true);
sFrame.setLocation(10,10);

}catch(Exception exc){ System.out.println("exception :"+exc); }
}

}
