import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.sql.*;
import java.util.*;

public class SwingApplication implements ActionListener { 

		
	      DbConnect db=null;
	      Properties dbProps = null;
	      Connection conn=null;
	      ResultSet rs=null;
	      Statement stmt;
	      static JFrame frame;
              JLabel passlabel = new JLabel("Password");
              JLabel userlabel = new JLabel("User");
              JTextField user;
              JPasswordField pass;
              JButton loginButton;
              JButton resetButton;
              JButton signUpButton;

public SwingApplication()
{

}

public Component createComponents1() { 

	          userlabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
                  passlabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));

                  user = new JTextField(8);
                  pass = new JPasswordField(8);

                  JPanel pane1 = new JPanel(new GridLayout(2,2));
                  pane1.setBorder(BorderFactory.createEmptyBorder(30,30,10,30));

                  pane1.add(userlabel);
                  pane1.add(user);
 		  pane1.add(passlabel);
                  pane1.add(pass);

                  return pane1;

                   }

               public Component createComponents2() {
 
             

                  signUpButton = new JButton("Sign Up");
                  signUpButton.setMnemonic(KeyEvent.VK_I);
                  signUpButton.addActionListener(this);
                                                                                                                             
 
                  loginButton = new JButton("Sign in");
                  loginButton.setMnemonic(KeyEvent.VK_I);
                  loginButton.addActionListener(this);
                                                                                                                             
                  resetButton = new JButton("Cancel");
                  resetButton.setMnemonic(KeyEvent.VK_C);
                  resetButton.addActionListener(this);

                
		  JPanel pane2 = new JPanel(new GridLayout(1,3));
                  pane2.setBorder(BorderFactory.createEmptyBorder(30,30,10,30));


                  pane2.add(signUpButton);
                  pane2.add(loginButton);
                  pane2.add(resetButton);

 			return pane2;


        }



public void actionPerformed(ActionEvent e) 
{

        String password=new String();
	String loginName=new String();

	if(("Sign Up".equals(e.getActionCommand()))||("Sign in".equals(e.getActionCommand())))
	{

	  try{
                String driver = "com.mysql.jdbc.Driver";
                Class.forName(driver);
                FileInputStream fis = new FileInputStream("/users/pg04/sreekanth/swings/db.conf");
                dbProps = new Properties();
                dbProps.load(fis);
                int dbPort = Integer.parseInt(dbProps.getProperty("dbport"));
                String dbHost = dbProps.getProperty("dbhost");
                String dbUser = dbProps.getProperty("dbuser");
                String dbPassword = dbProps.getProperty("dbpassword");
                String dbName = dbProps.getProperty("dbname");
                String dbType = dbProps.getProperty("dbtype");
                String jdbcString = "jdbc:mysql://" + dbHost + "/" + dbName + "?user=" + dbUser +"&password=" + dbPassword;
                conn = DriverManager.getConnection(jdbcString);
                stmt = conn.createStatement();
            }
        catch(ClassNotFoundException e12) {
            System.out.println("Driver Can't be loaded");
                                        }
         catch(IOException e2)  {
            System.out.println("File Exception:"+e2);
                                }

         catch(Exception e3)  {
            System.out.println("Exception:"+e3);
                                }

	char[] pC=pass.getPassword();
        password=new String(password.valueOf(pC));
	loginName=user.getText();

	}
	if("Sign Up".equals(e.getActionCommand()))
	{
	  System.out.println("==="+loginName);
	   signUpUser(loginName,password);
	}
	else if("Sign in".equals(e.getActionCommand()))
	{
	signInUser(loginName,password);
	}
	else
	{
	// exit bcoz u have clicked cancel
	System.out.println("Application is now closed");
	frame.dispose();
	System.exit(0);
	}
}				


public void signUpUser(String loginName,String password)
{ 
System.out.println("iam signing up");
if((loginName.length()==0)||(password.length()==0))
{
JOptionPane.showMessageDialog(frame, "Login name and/or Password cannot be empty");
}
else
{
clearTextFields();
String query="select count(*) from G24_T1 where login_name='"+loginName+"' and password='"+password+"'";
System.out.println("the query executed is :"+query);
try{
                PreparedStatement p=conn.prepareStatement(query);
                rs=null;
                rs=p.executeQuery();
		rs.next();
                System.out.println("the query is executed...."+rs.getString(1));
		if("1".equals(rs.getString(1)))
		{
		JOptionPane.showMessageDialog(frame, "Login name already exists. Please register with another login name");
		clearTextFields();
		return;
		}
		else
		{
		query="insert into G24_T1 values('"+loginName+"','"+password+"',0)";
		System.out.println("the query executed is :"+query);
		p=conn.prepareStatement(query);
                rs=null;
                p.executeUpdate();
                System.out.println("the query is executed....");
		JOptionPane.showMessageDialog(frame,loginName+" has been successfully Registered\n Now you can sign in");
		}

  }// end try block
catch(Exception e) {
           System.out.println("Exception:"+e);
                 }

}
}//end of signUpUser 

public void signInUser(String loginName,String password)
{
/*	System.out.println("iam signing In");
	char[] p1=pass.getPassword();
	String pS=new String();*/
	int valid;
	if((loginName.equals("admin"))&&(password.equals("admin")))
	{
	System.out.println("admin has loged in");
	frame.dispose();
	AdminUser admin=new AdminUser(conn);
	admin.CreateComponents();
	}
        else
	{
        valid=checkUser(loginName,password);
	clearTextFields();
	if(valid==1)
	{
	System.out.println("valid user and first time sign in"+valid);
        DataEntryForm dataForm=new DataEntryForm(loginName,conn);
	frame.setVisible(false);
	dataForm.createAndShowGUI();
	}
	else if(valid==2)
	{
        System.out.println("valid user and not first time sign in"+valid);
	AnalysisForm analysis=new AnalysisForm(loginName,conn);
	frame.setVisible(false);
	analysis.createAndShowGUI();
	}
	else{
        System.out.println("Invalid user or password.");
	JOptionPane.showMessageDialog(frame, "Invalid user.\n You can resigster using sign up button");
	}
	}
}



private void clearTextFields()
{

	System.out.println("iam clearing text fields");
	pass.setText("");
	user.setText("");
}	

private int checkUser(String user,String password)
/*	returns 0: if not a valid login
 *	returns 1: if a valid login but has signed in for first time
 *	returns 2: if a valid login and its not the first time he is signing up
 */

{	
	int valid=0;
	String query="select * from G24_T1 where login_name='"+user+"' and password='"+password+"'";
	System.out.println("the query executed is :"+query);
	 try{
        	PreparedStatement p=conn.prepareStatement(query);
		rs=null;
	        rs=p.executeQuery();
        	System.out.println("the query is executed....");
		if(rs.next())
		{
		  if(0==(Integer.parseInt(rs.getString(3))))
		  valid=1;
		  else
		  valid=2;
		}
	    }	
	catch(Exception e) {
            System.out.println("Exception:"+e);
        	            }
return valid;
}

    public void createAndShowGUI() {
        //creating and showing this application's GUI.
	/*	MenuBar mbar=new MenuBar();
                MenuItem item1;
                Menu opt=new Menu("Options");
                opt.add(item1=new MenuItem("Sign Up"));
                mbar.add(opt);
                item1.addActionListener(this);*/


          JFrame.setDefaultLookAndFeelDecorated(true);

         frame = new JFrame("Authenticate");
         frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
          
         frame.setSize(new Dimension(120, 40));


         SwingApplication app = new SwingApplication();
         Component contents1 = app.createComponents1();
         Component contents2 = app.createComponents2();
   
         frame.getContentPane().add(contents1, BorderLayout.NORTH);
         frame.getContentPane().add(contents2, BorderLayout.CENTER);



          frame.pack();
          frame.setVisible(true);
  }

  /* public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
		createAndShowGUI();
               }

            });

        }*/

 }



       

