import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import java.awt.geom.*;

public class scatter extends JComponent {
 static int[] xAxis;
 static int[] yAxis;
 static int n;
 
 final static int maxCharHeight = 15;
 final static int minFontSize = 6;
 
 final static Color red = Color.red;
 final static Color bg = Color.white;
 final static Color fg = Color.black;
 final static BasicStroke stroke = new BasicStroke(6.0f);
 final static BasicStroke wideStroke = new BasicStroke(8.0f);


 String mycolor,grid;
 Properties props=null;



public void getX(int[] a)
{
xAxis=a;
}
public void getY(int[] b)
{
yAxis=b;
}

public void getN(int no)
{
n=no;
}

// FontMetrics Metrics;
public void scatter() {
  try{FileInputStream fis=new FileInputStream("scatterconfig.cfg");
        props=new Properties();
        props.load(fis);
        mycolor=props.getProperty("color");
        grid=props.getProperty("grid");
	System.out.println("the options are ----->:"+mycolor+" and "+grid);
     }catch(Exception exc){ System.out.println("exception "+exc); }
 
 setBackground(bg);
 setForeground(fg);
// repaint();
 }


 public void paint (Graphics g) {

 Graphics2D g2 = (Graphics2D) g;

 g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);

 g2.setPaint(Color.black);
 
 g2.setFont(new Font("Arial", Font.BOLD, 10));
// Metrics = g2.getFontMetrics();

 int x=80;
 int y=600;

 
// g2.setStroke(stroke);
 g2.draw(new Line2D.Double(x-10, y, x-10, y-600));
 g2.draw(new Line2D.Double(x-10, y, x+600,y));
 int d=0;
 int f=0;
 String z; 
 for(int i=0;i<11;i++)
   {
     f=y-(50*(i+1));
     d=x+(50*(i+1));
     z="" + i;
     g2.setPaint(Color.black);
     g2.drawString(z,x-40,f); 
     g2.drawString(z,d,y+40);
     g2.setPaint(Color.white);
     g2.draw(new Line2D.Double(x-10,f,x+600,f));
     g2.draw(new Line2D.Double(d,y-600,d,y));
   }
   g2.draw(new Line2D.Double(x-10,y-600,x+600,y-600));
   g2.draw(new Line2D.Double(d+50,y-600,d+50,y));
   g2.setStroke(stroke);  
   g2.setPaint(getColor()); 
  for(int i=0;i<n;i++)
    g2.draw(new Line2D.Double(x+(50*xAxis[i])+50,y-(50*yAxis[i])-50,x+(50*xAxis[i])+50,y-(50*yAxis[i])-50));
}



Color getColor()
{
System.out.println("---"+mycolor);
if("red".equals(mycolor)) return Color.red;
else if("green".equals(mycolor)) return Color.green;
else if("blue".equals(mycolor)) return Color.blue;
else if("yellow".equals(mycolor)) return Color.yellow;
else if("white".equals(mycolor)) return Color.white;
else  return Color.black;
}
}
